﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using Telerik.XamarinForms.DataGrid;
using Xamarin.Forms;

namespace gauge
{
    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(false)]
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            this.BindingContext = new ColumnsViewModel();


            this.datagrid.Columns.Add(new DataGridTemplateColumn
            {
                HeaderText = "Req. Mts",
                CellContentTemplate = new DataTemplate(() => {
                    Entry entry = new Entry();
                    entry.FontSize = 16;
                    entry.InputTransparent = false;
                    entry.Keyboard = Keyboard.Numeric;
                    entry.SetBinding(Entry.TextProperty, "StadiumCapacity", BindingMode.TwoWay);

                    /** some code to implement image**/
                    return entry;
                })
            });
        }
    }

    public class ColumnsViewModel
    {
        public ObservableCollection<Club> Clubs { get; set; }

        public ColumnsViewModel()
        {
            this.Clubs = new ObservableCollection<Club>
            {
                new Club(45362),
                new Club(76212),
                new Club(42055),
                new Club(99354)
            };
        }
    }

    public class Club : INotifyPropertyChanged
    {
        
        private int stadiumCapacity;

        public Club(int stadiumCapacity)
        {
           
            StadiumCapacity = stadiumCapacity;
           
        }

        public int StadiumCapacity
        {
            get { return this.stadiumCapacity; }
            set { this.UpdateValue(ref this.stadiumCapacity, value); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        protected void UpdateValue<T>(ref T field, T newValue, [CallerMemberName] string propertyName = null)
        {
            if (!object.Equals(field, newValue))
            {
                field = newValue;
                this.OnPropertyChanged(propertyName);
            }
        }
    }
}
